=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class LineItem
    # Currency of the total_price amount.
    attr_accessor :currency

    # Country the item was manufactured in. In the Shippo dashboard, this value will be used ot pre-fill the customs declaration when creating a label for this order.
    attr_accessor :manufacture_country

    # The date and time this item needs to be delivered by, i.e. by when the carrier delivers it to the buyer.
    attr_accessor :max_delivery_time

    # The date and time this item needs to be fulfilled by, i.e. by when the shipping label needs to be created and handed over to the carrier.
    attr_accessor :max_ship_time

    # The quantity of this item in this order.
    attr_accessor :quantity

    # The stock keeping unit value of this item.
    attr_accessor :sku

    # Title of the line item.
    attr_accessor :title

    # Total price paid by the buyer for this item (or these items, if quantity > 1).
    attr_accessor :total_price

    # A variant is a specific variation of an item (e.g. \"size M\" or \"color blue\"). Variants might be exposed as a separate resource in the future too. Currently the variant title is a free text field describing the variant.
    attr_accessor :variant_title

    # Total weight of this/these item(s). Instead of specifying the weight of all items, you can also set the total_weight value of the order object.
    attr_accessor :weight

    # The unit used for the weight field
    attr_accessor :weight_unit

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'currency' => :'currency',
        :'manufacture_country' => :'manufacture_country',
        :'max_delivery_time' => :'max_delivery_time',
        :'max_ship_time' => :'max_ship_time',
        :'quantity' => :'quantity',
        :'sku' => :'sku',
        :'title' => :'title',
        :'total_price' => :'total_price',
        :'variant_title' => :'variant_title',
        :'weight' => :'weight',
        :'weight_unit' => :'weight_unit'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'currency' => :'Object',
        :'manufacture_country' => :'Object',
        :'max_delivery_time' => :'Object',
        :'max_ship_time' => :'Object',
        :'quantity' => :'Object',
        :'sku' => :'Object',
        :'title' => :'Object',
        :'total_price' => :'Object',
        :'variant_title' => :'Object',
        :'weight' => :'Object',
        :'weight_unit' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::LineItem` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::LineItem`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.key?(:'manufacture_country')
        self.manufacture_country = attributes[:'manufacture_country']
      end

      if attributes.key?(:'max_delivery_time')
        self.max_delivery_time = attributes[:'max_delivery_time']
      end

      if attributes.key?(:'max_ship_time')
        self.max_ship_time = attributes[:'max_ship_time']
      end

      if attributes.key?(:'quantity')
        self.quantity = attributes[:'quantity']
      end

      if attributes.key?(:'sku')
        self.sku = attributes[:'sku']
      end

      if attributes.key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.key?(:'total_price')
        self.total_price = attributes[:'total_price']
      end

      if attributes.key?(:'variant_title')
        self.variant_title = attributes[:'variant_title']
      end

      if attributes.key?(:'weight')
        self.weight = attributes[:'weight']
      end

      if attributes.key?(:'weight_unit')
        self.weight_unit = attributes[:'weight_unit']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      weight_unit_validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      return false unless weight_unit_validator.valid?(@weight_unit)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] weight_unit Object to be assigned
    def weight_unit=(weight_unit)
      validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      unless validator.valid?(weight_unit)
        fail ArgumentError, "invalid value for \"weight_unit\", must be one of #{validator.allowable_values}."
      end
      @weight_unit = weight_unit
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          currency == o.currency &&
          manufacture_country == o.manufacture_country &&
          max_delivery_time == o.max_delivery_time &&
          max_ship_time == o.max_ship_time &&
          quantity == o.quantity &&
          sku == o.sku &&
          title == o.title &&
          total_price == o.total_price &&
          variant_title == o.variant_title &&
          weight == o.weight &&
          weight_unit == o.weight_unit
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [currency, manufacture_country, max_delivery_time, max_ship_time, quantity, sku, title, total_price, variant_title, weight, weight_unit].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
